#!/bin/bash
# -*- coding: utf-8 -*-

# urlwrap.sh -- provide "URL capabilities" to non-URL-aware programs
#
# Copyright (c) 2007 Ville Skyttä <scop@fedoraproject.org>
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.

cmd=()
tmpdir=
curlopts="--silent --insecure"
myself=$(basename $0)

shopt -s extglob

trap cleanup EXIT
cleanup()
{
    set +e
    [ -z "$tmpdir" -o ! -d "$tmpdir" ] || rm -rf "$tmpdir"
}

if [[ "$1" == @(--help|-h) ]] ; then
    cat <<EOF
Usage: $myself [PROGRAM] [PROGRAM_ARGS]... -- [URLS]

Fetches the given URLs into temporary files and feeds them to the given
program after the given program arguments.
EOF
    exit 0
fi

tmpdir=$(mktemp -d "/tmp/$myself.XXXXXX") || exit $?

while [ $# -gt 0 ] ; do
    case "$1" in
        --) shift ; break ;;
        *)  cmd[${#cmd[@]}]="$1" ;;
    esac
    shift
done

i=1
for url in "$@" ; do
    output="$tmpdir/$i.$(basename ""$url"")"
    curl $curlopts -o "$output" "$url"
    cmd[${#cmd[@]}]="$output"
    i=$((i + 1))
done

${cmd[@]}
